float4x4 matWorldViewProj;

Texture TargetMap;
sampler ColorMapSampler = sampler_state
{
	texture = <TargetMap>;
	mipfilter = LINEAR;
};

Texture mtlSkin1;
sampler ShadowMapSampler = sampler_state
{
	texture = <mtlSkin1>;
	mipfilter = LINEAR;
};
struct combiVS
{
    float4 Pos     : POSITION;
    float2 TexCoord   : TEXCOORD0;
    float4 Screen    : TEXCOORD1;
};
combiVS vs_main(in float4 inPos: POSITION,
		in float2 inTex: TEXCOORD0)
{
	combiVS Out;
		Out.Pos = mul(inPos, matWorldViewProj);
		
	Out.TexCoord = inTex;
	Out.Screen.x = ( Out.Pos.x + Out.Pos.w)*0.5;
	Out.Screen.y = (-Out.Pos.y + Out.Pos.w)*0.5;
	Out.Screen.z =Out.Pos.z;
	Out.Screen.w = Out.Pos.w;
		return Out;
}

float4 ps_main(/*combiVS In*/ in float4 TexCoord : TEXCOORD0) : COLOR0
{
	float4 Color = tex2D(ColorMapSampler,TexCoord);
	//float4 Shadow = tex2Dproj(ShadowMapSampler,TexCoord);
	float4 Shadow = tex2D(ShadowMapSampler,TexCoord);   	
	Color.a = 1.0;
	Shadow.a = 1.0;
   return Color*Shadow;
}

technique Main
{
	pass RenderShadowMap
	{
		//VertexShader = compile vs_2_0 vs_main();
		PixelShader = compile ps_2_0 ps_main();
	}
}