//////////////////////////////////depthshader by redphoenix////////////////////////////////////
// basis: http://ati.amd.com/developer/gdc/Scheuermann_DepthOfField.pdf ///////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
float4 vecSkill1; //x: near full blurring state, y focal plane, z far full blurring state, w = max value of blurriness
struct VS_IN
{
	float4 position : POSITION;
};

struct VS_OUT
{
	float4 position : POSITION;
	float  depth    : TEXCOORD0;
};

float4x4 matWorldViewProj : WorldViewProjection;


VS_OUT depth_vs (VS_IN In)
{
	VS_OUT Out;
	Out.position = mul(In.position, matWorldViewProj);
	Out.depth = Out.position.z;
	return Out;
}

float4 depth_ps (VS_OUT In) : COLOR0
{  vecSkill1.y*=0.5;
	float final_depth;
	if (In.depth < vecSkill1.y) {
		final_depth = (In.depth-vecSkill1.y)/(vecSkill1.y-vecSkill1.x);
	}
	else {
		final_depth = (In.depth-vecSkill1.y)/(vecSkill1.z-vecSkill1.y);
		final_depth = clamp(final_depth,0,vecSkill1.w);
	}
	return (final_depth*0.5f+0.5f);
}

technique depth
{
	pass p0
	{
		VertexShader = compile vs_2_0 depth_vs();
		PixelShader = compile ps_2_0 depth_ps();
	}
}