//////////////////////////////////////////////////
////////////A simple Box Blur Shader//////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////14.01.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////

texture TargetMap;
sampler boxMapSampler = sampler_state
{
Texture = <TargetMap>;
mipfilter = LINEAR;
};
float4 vecViewPort;

//Box Blur
const float4 samples[4] =
{
   -1.0,  0.0, 0, 0.25,
    1.0,  0.0, 0, 0.25,
    0.0,  1.0, 0, 0.25,
    0.0, -1.0, 0, 0.25
};

float4 ps_main(float2 TexCoord : TEXCOORD0) : COLOR0
{
   float4 Color = 0;
   
   // Sample and output the box averaged colors
   for(int i=0; i<4; i++)
      Color += samples[i].w*tex2D(boxMapSampler,TexCoord+float2(samples[i].x*vecViewPort.z,samples[i].y*vecViewPort.w));
   
   Color.a = 1.0;
   return (Color);
}

technique Main
{
	pass RenderShadowMap
	{
		PixelShader = compile ps_2_0 ps_main();
	}
}