		//Variables set by the engine:
		float4 vecViewPort;
		
		//Textures:
		texture TargetMap;
		texture mtlSkin1;
		
		//Sampler:
		sampler smpTarget = sampler_state { Texture = <TargetMap>; };
		sampler smpSkin1 = sampler_state { Texture = <mtlSkin1>; };

/////////////////////////////////////////////////////////
//		//Real Anaglyphs
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Grey Anaglyphs:
		float4x4 matView1ColTrans =
		{
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.299,	0.587,	0.114,	0.0,
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		1.0
		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Colored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Halfcolored Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		1.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
/*		//Optimised Anaglyphs:
		float4x4 matView1ColTrans =
		{
			0.0,		0.7,		0.3,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
/////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//		//Amber-Blue Anaglyphs:
//		float4x4 matView1ColTrans =
//		{
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.299,	0.587,	0.114,	0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
//		
//		float4x4 matView2ColTrans =
//		{
//			1.0,		0.0,		0.0,		0.0,
//			0.0,		1.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		0.0,
//			0.0,		0.0,		0.0,		1.0
//		};
/////////////////////////////////////////////////////////

		
		float4 PixeShader(float2 TexCoords : TEXCOORD0) :COLOR
		{
			//Get the texturepixels colors
			float4 ColorView1 = tex2D(smpTarget,TexCoords);
			float4 ColorView2 = tex2D(smpSkin1,TexCoords);
			
			//calculate the resulting color
			float4 Color = mul(matView1ColTrans,ColorView1)+mul(matView2ColTrans,ColorView2);

			return Color;
		}
		
		technique PPE
		{
			pass p1
			{
				PixelShader = compile ps_1_4 PixeShader();
			}
		}