Texture TargetMap;
texture StencilMap;

sampler2D g_samSrcColor = sampler_state { texture = <StencilMap>; MipFilter = Linear;	};
sampler2D g_samSrcSource = sampler_state { texture = <TargetMap>; MipFilter = Linear;	};

float4 vecViewPort;
float4 vecSkill1;

float4 postprocessing_gaussian(float2 Tex : TEXCOORD0) : COLOR0 
{   
   float4 sampleM  = tex2D(g_samSrcColor, Tex.xy);
	float4 sampleB0 = tex2D( g_samSrcColor, Tex.xy - vecViewPort.zw );
	float4 sampleF0 = tex2D( g_samSrcColor, Tex.xy + vecViewPort.zw );
	float4 sampleB1 = tex2D( g_samSrcColor, Tex.xy - vecViewPort.zw*2. );
	float4 sampleF1 = tex2D( g_samSrcColor, Tex.xy + vecViewPort.zw*2. );
	float4 sampleB2 = tex2D( g_samSrcColor, Tex.xy - vecViewPort.zw*3. );
	float4 sampleF2 = tex2D( g_samSrcColor, Tex.xy + vecViewPort.zw*3. );
	
	return tex2D(g_samSrcSource, Tex.xy)-vecSkill1.y*(0.1752 * sampleM.a + 0.1658 * (sampleB0.a + sampleF0.a) + 0.1403 * (sampleB1.a + sampleF1.a) + 0.1063 * (sampleB2.a + sampleF2.a));
//return sampleM;
}

technique PostProcess 
{
	pass p1 
	{
		AlphaBlendEnable = false;	
		VertexShader = null;
		PixelShader = compile ps_2_0 postprocessing_gaussian();
	}
}
