Texture mtlSkin2; //bloomed szene fragment
texture mtlSkin1; //Original Scene
Texture mtlSkin3; //gamma

float4 vecSkill1;

float4 vecViewPort;

sampler originalImageSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler blurImageSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler gammaImageSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = wrap;
   AddressV = wrap;
};
float4 main(float2 tc: TEXCOORD0, float2 tc2: TEXCOORD1) : COLOR{
	float fExposureLevel= 2.0f;
	//float4 original = tex2D(originalImageSampler, tc/float2(2.5,3.74)); //640x480
	//float4 original = tex2D(originalImageSampler, tc/float2(3.15,2.35)); //800x600
	//float4 original = tex2D(originalImageSampler, tc/float2(4,3)); //1024x768
	float4 original = tex2D(originalImageSampler, tc/float2(vecViewPort.x/vecSkill1.w,vecViewPort.y/vecSkill1.w));
	float4 blur = tex2D(blurImageSampler, tc/4);
	float4 gamma = tex2D(gammaImageSampler, tc*4);	
	float4 color = lerp(original, blur,0.45f);
	
	//tc -= float2(2.0f,1.5f); // Put coordsin -1/2 to 1/2 range
	tc-=float2(0.78,0.58);
	
	//tc /= 5;
	
	// Square of distance from origin (center of screen)
	float vignette = max(1.0 -dot(tc, tc),0.3);
	// Multiply by vignette to the fourth
	color = color * pow( vignette, 0.20 );
	color += color*(1-gamma.x)*fExposureLevel; // Apply simple exposure level
	return pow(color, vecSkill1.x); // Apply gamma and return
}

technique HDR {
pass p1 {
	VertexShader = null;
	PixelShader = compile ps_2_0 main();
	}
}