 float4 vecAmbient;
float4 vecDiffuse;
float4 vecEmissive;
float fAmbient;
float fAlpha;
float fAlbedo;
float4 vecColor;
float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matWorldInv;
float4x4 matWorldView;
float2 filter2 = { 0.25,0.0 };
float2 filter3 = { 0.0,0.25 };
float2 filter4 = { 0.5, 0.0 };
float2 filter5 = { 0.0, 0.5 };
float4 vecFog;
float4 vecViewPos;
float DoFog(float4 Pos)	{ float3 P = mul(Pos,matWorldView); return saturate((vecFog.y-P.z) * vecFog.z); }
float3 vecSunPos;
float4 vecSunColor;
float3 vecSunDir;
float4 vecSunDiffuse = float4(255.f/255.f, 255.f/255.f, 255.f/255.f, 1.f);
float4 vecLight;
float4 vecLightPos[8];
float4 vecLightDir[8];
float4 vecLightColor[8];
float3 vecFalloff = float3(0.f, 0.f, 1.5f);
Texture mtlSkin1;
sampler sBaseTex = sampler_state {
Texture = <mtlSkin1>;
MinFilter = Linear;
MagFilter = Linear;
MipFilter = Linear;
AddressU  = clamp;
AddressV  = clamp;
};
float4 vecSkill1;
struct out_terraintex3 {
float4 Pos		: POSITION;
float4 Color	: COLOR0;
float  Fog		: FOG;
float3 MaskCoord: TEXCOORD0;
float3 Sun		: TEXCOORD1;
float3 View		: TEXCOORD2;
float3 Clip        :TEXCOORD3;
};
out_terraintex3 vs_terraintex3(float4 inPos : POSITION,float3 inNormal : NORMAL,float4 inTangent : TEXCOORD2,float2 inTexCoord0 : TEXCOORD0) {
out_terraintex3 Out;
float3x3 worldToTangentSpace;
worldToTangentSpace[0] = mul(inTangent.xyz, matWorld);
worldToTangentSpace[1] = mul(cross(inTangent.xyz, inNormal)*inTangent.w, matWorld);
worldToTangentSpace[2] = mul(inNormal, matWorld);
Out.Pos = mul(inPos,matWorldViewProj);
float4 P = mul(inPos,matWorld);
float4 Viewer = P - vecViewPos;
Out.View = mul(worldToTangentSpace, -Viewer);
Out.Sun = normalize(mul(worldToTangentSpace, -vecSunDir));
#ifndef NORMALMAPPING
float3 objSunDir = normalize(mul(-vecSunDir.xyz, matWorldInv));
float  sunDiff   = max(dot(inNormal, objSunDir), 0);
Out.Color        = float4(vecSunColor.rgb * sunDiff, 0)*vecDiffuse.rgba*fAlbedo*4 + vecAmbient.rgba*float4(vecColor.rgb,fAlpha);
#else
Out.Color = vecAmbient.rgba*float4(vecColor.rgb,fAlpha);
#endif
#ifdef DYN_LIGHT
for(int i = 0;
 i < 0;i++) {
float4 objLightPos  = mul(float4(vecLightPos[i].xyz, 1), matWorldInv);
float4 objLightDir  = objLightPos - inPos;
 float4 objLightDirN;
if (!vecLightDir[i].x && !vecLightDir[i].y && !vecLightDir[i].z) objLightDirN = normalize(objLightDir);
else objLightDirN = normalize(mul(-vecLightDir[i].xyz, matWorldInv));
float  diffLight    = max(dot(objLightDirN, inNormal), 0);
float falloffFactor = 0;
if(vecLightPos[i].w > 0) {
float linearDistance = length(objLightDir)/vecLightPos[i].w;
if(linearDistance < 1) falloffFactor = 1 - linearDistance;
}
diffLight *= falloffFactor;
Out.Color.rgb  += vecLightColor[i].rgb * diffLight*vecDiffuse.rgb*fAlbedo*4;
}
#endif
Out.Fog = DoFog(inPos);
Out.Clip = -vecSkill1.z+P;
Out.MaskCoord.xy = inTexCoord0.xy;
Out.MaskCoord.z = Out.Pos.z;
return Out;
}

float4 ps_terraintex3_1(out_terraintex3 In): COLOR {
if(vecSkill1.w<0){clip(In.Clip.y);}
float3 ViewDir = normalize(In.View);
float Height = 0.0;
float4 BaseColor = tex2D(sBaseTex,frac(Height * ViewDir + In.MaskCoord.xy*1));
float4 FinalColor = BaseColor;
FinalColor = FinalColor*In.Color;
FinalColor = FinalColor+(FinalColor*float4(vecEmissive.rgb,1.0)*fAmbient*2);
FinalColor.a = fAlpha;
return FinalColor;
}
technique terraintex3_13 {
 pass one {
sampler[0] = (sBaseTex);
alphaBlendEnable = true;
zenable=true;
zwriteenable=true;
VertexShader = compile vs_2_0 vs_terraintex3();
PixelShader = compile ps_2_0 ps_terraintex3_1();
}

}